﻿601,100
562,"CHARACTERDELIMITED"
586,"dummy.txt"
585,"dummy.txt"
564,
565,"wFnE2I6]WZMT>\Bgp1EBGKyaE`xe<^gLYytm@NcqFFfTvDfn5;C]LWL>Vfu0v@EZb6kMyCwJRWu:j`1a03<NbFaCu>Xrv@j3l:T;p4;<h3ol=6d4uIh6YqUuDvaiUC:zI1Qy>>?db^?3EuSx=fZdoIlx<hePofeBIm[mdx?IsN46Vq:Jtq[SU>5B8;MLQwHdGoqPbSVi"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,"	"
588,","
589,"."
568,""""
570,
571,
569,0
592,0
599,1000
560,5
pExecutionId
pAppId
pReviewerEditOn
pSourceFile
pControl
561,5
2
2
2
2
2
590,5
pExecutionId,"None"
pAppId,"MyApp"
pReviewerEditOn,"F"
pSourceFile,"None"
pControl,"N"
637,5
pExecutionId,
pAppId,
pReviewerEditOn,
pSourceFile,
pControl,
577,5
vNode
vGroup
vRight
vViewDepth
vReviewDepth
578,5
2
2
2
2
2
579,5
1
2
3
4
5
580,5
0
0
0
0
0
581,5
0
0
0
0
0
582,5





572,207


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


cControlPrefix = '';
If (pControl @= 'Y');
cControlPrefix = '}';
EndIf;

#*** Log File Name
cTM1Process = cControlPrefix | 'tp_add_user_security_from_file';
StringGlobalVariable('gPrologLog');
StringGlobalVariable('gEpilogLog');
StringGlobalVariable('gDataLog');
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_log_file_names',
'pExecutionId', pExecutionId, 'pProcess', cTM1Process, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
cPrologLog = gPrologLog;
cEpilogLog = gEpilogLog;
cDataLog = gDataLog;
cTM1Log = cPrologLog;

cConfigDim = cControlPrefix | 'tp_config';
If (DimensionExists(cConfigDim) = 1);
cGenerateLog = ATTRS(cControlPrefix | 'tp_config', 'Generate TI Log', 'String Value');
Else;
cGenerateLog = 'N';
EndIf;

#*** Get lock

cLock = 'Lock';
cId = 'Id';
cSemaphoreCube = cControlPrefix | 'tp_semaphore';

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Start getting lock');
EndIf;

CellPutS(pExecutionId, cSemaphoreCube, cLock, cId);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Finish getting lock');
EndIf;

#*** Log Parameters

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Parameters:',
pExecutionId, pAppId, pReviewerEditOn, pSourceFile, pControl);
EndIf;

#*** Set local variables
DataSourceType = 'CHARACTERDELIMITED';
DatasourceASCIIDelimiter = CHAR(9);
DatasourceASCIIHeaderRecords = 0;
DatasourceNameForServer = pSourceFile;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'DataSourceType: ' | DataSourceType);
TextOutput(cTM1Log, 'DatasourceASCIIDelimiter: ' | DatasourceASCIIDelimiter);
TextOutput(cTM1Log, 'DatasourceASCIIHeaderRecords: ' | NumberToString(DatasourceASCIIHeaderRecords));
TextOutput(cTM1Log, 'DatasourceNameForServer: ' | DatasourceNameForServer);
EndIf;

#*** Set input file encoding as UTF-8

SetInputCharacterSet('TM1CS_UTF8');

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check application dimension');
EndIf;

cApplicationsDim = cControlPrefix | 'tp_applications';

If (DimensionExists(cApplicationsDim) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_DIM_NOT_EXIST',
'pErrorDetails', cApplicationsDim,
'pControl', pControl);

ProcessError;
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check application id', pAppId);
EndIf;

If (DIMIX(cApplicationsDim, pAppId) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', cApplicationsDim | ', ' | pAppId,
'pControl', pControl);

ProcessError;
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check permission cube');
EndIf;

cPermissionCube = cControlPrefix | 'tp_application_permission}' | pAppId;
If (CubeExists(cPermissionCube) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_CUBE_NOT_EXIST',
'pErrorDetails', cPermissionCube,
'pControl', pControl);

ProcessError;
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Get Approval dimension and subset');
EndIf;

StringGlobalVariable('gApprovalDim');
StringGlobalVariable('gApprovalSubset');
StringGlobalVariable('gSecuritySet');
StringGlobalVariable('gApprovalSubsetComplementMdx');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_application_attributes',
'pExecutionId', pExecutionId, 'pAppId', pAppId, 'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cApprovalDim = gApprovalDim;
cApprovalSubset = gApprovalSubset;
cSecuritySet = gSecuritySet;
cApprovalSubsetComplementMdx = gApprovalSubsetComplementMdx;
cApprovalDimSize = DIMSIZ(cApprovalDim);
cApprovalSubsetSize = SubsetGetSize(cApprovalDim, cApprovalSubset);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 
'tp_get_application_attributes', cApprovalDim, cApprovalSubset, cSecuritySet);
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'),
'gApprovalSubsetComplementMdx', gApprovalSubsetComplementMdx);
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'Check cell level security cube');
EndIf;

cCellSecurityCube = '}CellSecurity_' | cPermissionCube;

If (CubeExists(cCellSecurityCube) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_CUBE_NOT_EXIST',
'pErrorDetails', cCellSecurityCube,
'pControl', pControl);

ProcessError;
Else;
CubeSetLogChanges(cCellSecurityCube, 0);
EndIf;

#***
StringGlobalVariable('gTopNode');
NumericGlobalVariable('gTopLevel');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_get_top_node',
'pExecutionId', pExecutionId, 'pDim', cApprovalDim, 'pSubset', cApprovalSubset);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 
'tp_get_top_node', gTopNode, NumberToString(gTopLevel));
EndIf;

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;


573,1

574,594


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


#*** Log File Name
cTM1Log = cDataLog;

cRightView = 'VIEW';
cRightEdit = 'EDIT';
cRightSubmit = 'SUBMIT';
cRightReview = 'REVIEW';

cView = 'VIEW';
cAnnotate = 'ANNOTATE';
cEdit = 'EDIT';
cReject = 'REJECT';
cSubmit = 'SUBMIT';

IF (pReviewerEditOn @= 'T');
cReviewerEditOn ='T';
Else;
cReviewerEditOn = 'F';
ENDIF;

cViewDepth = NUMBR(vViewDepth);
cReviewDepth = NUMBR(vReviewDepth);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Security set', cSecuritySet);
EndIf;

cRead = 'read';
cNone = 'none';
If (cSecuritySet @<> 'Y');
cRead = 'READ';
cNone = 'NONE';
EndIf;

#***

If (DIMIX(cApprovalDim, vNode) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_NODE_NOT_EXIST',
'pErrorDetails', cApprovalDim | ', ' | vNode,
'pControl', pControl);

ProcessError;
EndIf;

If (DIMIX('}Groups', vGroup) = 0);
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_GROUP_NOT_EXIST',
'pErrorDetails', '}Groups' | ', ' | vGroup,
'pControl', pControl);

ProcessError;
EndIf;

cNodePName = DimensionElementPrincipalName(cApprovalDim, vNode);
cGroupPName = DimensionElementPrincipalName('}Groups', vGroup);

If ((cNodePName @<> gTopNode) & (ELISANC(cApprovalDim, gTopNode, cNodePName) = 0));
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube', 
'pGuid', pExecutionId, 
'pProcess', cTM1Process, 
'pErrorCode', 'TI_NODE_NOT_EXIST_IN_SUBSET',
'pErrorDetails', cApprovalDim | ', ' | cApprovalSubset | ', ' | cNodePName,
'pControl', pControl);

ProcessError;
EndIf;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Get node and group principal name', cNodePName, cGroupPName);
EndIf;

# IF(1)
If (DTYPE(cApprovalDim, cNodePName) @= 'C');
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Consolidation node', cNodePName);
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Assign rights to self', cNodePName);
EndIf;

If (vRight @= cRightSubmit);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

ElseIf (vRight @= cRightReview);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

ElseIf (vRight @= cRightView);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

Else;

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_WRONG_PERMISSION',
'pErrorDetails', cNodePName | ', ' | vRight,
'pControl', pControl);

ProcessError;

EndIf;

#***

cLevel = ELLEV(cApprovalDim, cNodePName);
#IF(2)
If (cLevel > cReviewDepth);

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Level is greater than review depth: ' | NumberToString(cLevel));
EndIf;


cReviewDescendantsSubset = 'tp_temp_review_descendants_' | pExecutionId;
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Pass review right down, review depth: ' | vReviewDepth);
EndIf;

StringGlobalVariable('gMdxFindDescendants');

#IF(2.1)
If ((vRight @= cRightSubmit % vRight @= cRightReview) & (cReviewDepth > 0));

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', cApprovalDim, 'pSubset', '', 'pNode', cNodePName, 'pDepth', vReviewDepth, 'pSelf', 'Y');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetDestroy(cApprovalDim, cReviewDescendantsSubset);
SubsetCreateByMDX(cReviewDescendantsSubset, gMdxFindDescendants);

cReviewDescendantsSubsetSize = SubsetGetSize(cApprovalDim, cReviewDescendantsSubset);
vIndex = 1;
While (vIndex <= cReviewDescendantsSubsetSize);
vElement = SubsetGetElementName(cApprovalDim, cReviewDescendantsSubset, vIndex);
vElementPName = DimensionElementPrincipalName(cApprovalDim, vElement);

#IF(2.1.1)
If (vElementPName @<> cNodePName);

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cReject, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cView, cGroupPName);
EndIf;

#***Add additional privileges with reviewer edit on
#IF(2.1.1.1)
If (cReviewerEditOn @= 'T');

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;

If (DTYPE(cApprovalDim, vElementPName) @<> 'C');
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

Else;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

EndIf;

#IF(2.1.1.1)
Else;

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

#IF(2.1.1.1)
EndIf;

ElementSecurityPut(cRead, cApprovalDim, vElementPName, cGroupPName);

#IF(2.1.1)
EndIf;

vIndex = vIndex +1;
End;

SubsetDestroy(cApprovalDim, cReviewDescendantsSubset);

#IF(2.1)
EndIf;

#IF(2)
Else;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Level is less than or equal to review depth: ' | NumberToString(cLevel));
EndIf;

#IF(2.2)
If ((vRight @= cRightSubmit % vRight @= cRightReview));

vIndex = 1;
While (vIndex <= cApprovalDimSize);
vElement = DIMNM(cApprovalDim, vIndex);
#IF(2.2.1)
If (ELISANC(cApprovalDim, cNodePName, vElement) = 1);
vElementPName = DimensionElementPrincipalName(cApprovalDim, vElement);

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cReject, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cView, cGroupPName);
EndIf;

#***Add additional privileges with reviewer edit on
#IF(2.2.1.1)
If (cReviewerEditOn @= 'T');

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;

If (DTYPE(cApprovalDim, vElementPName) @<> 'C');
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

Else;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

EndIf;

#IF(2.2.1.1)
Else;

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;

#IF(2.2.1.1)
EndIf;

ElementSecurityPut(cRead, cApprovalDim, vElementPName, cGroupPName);

#IF(2.2.1)
EndIf;

vIndex = vIndex + 1;
End;

#IF(2.2)
EndIf;

#IF(2)
EndIf;

#***

#IF(3)
If (((vRight @= cRightSubmit % vRight @= cRightReview) & (cViewDepth > cReviewDepth)) %
    (vRight @= cRightView));

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Pass View right down, view depth: ' | vViewDepth);
EndIf;

#IF(3.1)
If (cLevel > cViewDepth);

cViewDescendantsSubset = 'tp_temp_view_descendants_' | pExecutionId;
vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_descendants', 
'pExecutionId', pExecutionId, 
'pDim', cApprovalDim, 'pSubset', '', 'pNode', cNodePName, 'pDepth', vViewDepth, 'pSelf', 'Y');
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;
SubsetDestroy(cApprovalDim, cViewDescendantsSubset);
SubsetCreateByMDX(cViewDescendantsSubset, gMdxFindDescendants);

cViewDescendantsSubsetSize = SubsetGetSize(cApprovalDim, cViewDescendantsSubset);
vIndex = 1;
While (vIndex <= cViewDescendantsSubsetSize);
vElement = SubsetGetElementName(cApprovalDim, cViewDescendantsSubset, vIndex);
vElementPName = DimensionElementPrincipalName(cApprovalDim, vElement);

If (vElementPName @<> cNodePName);

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, vElementPName, cGroupPName);

EndIf;

vIndex = vIndex +1;
End;

SubsetDestroy(cApprovalDim, cViewDescendantsSubset);

#IF(3.1)
Else;

vIndex = 1;
While (vIndex <= cApprovalDimSize);
vElement = DIMNM(cApprovalDim, vIndex);
#IF(3.1.1)
If (ELISANC(cApprovalDim, cNodePName, vElement) = 1);
vElementPName = DimensionElementPrincipalName(cApprovalDim, vElement);

vCellValue = CellGetS(cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, vElementPName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, vElementPName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, vElementPName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, vElementPName, cGroupPName);

#IF(3.1.1)
EndIf;

vIndex = vIndex + 1;
End;

#IF(3.1)
EndIf;

#IF(3)
Else;

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'No need to pass View right down, view depth: ' | vViewDepth);
EndIf;

#IF(3)
EndIf;

# IF(1)
Else;
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Leaf node', cNodePName);
EndIf;

If (vRight @= cRightSubmit);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

ElseIf (vRight @= cRightEdit);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

ElseIf (vRight @= cRightView);

vCellValue = CellGetS(cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cSubmit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cReject, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cReject, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cEdit, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cEdit, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
If (vCellValue @= '');
CellPutS(cNone, cCellSecurityCube, cNodePName, cAnnotate, cGroupPName);
EndIf;
vCellValue = CellGetS(cCellSecurityCube, cNodePName, cView, cGroupPName);
If (vCellValue @= '' % CODE(vCellValue, 1) <> CODE(cRead, 1));
CellPutS(cRead, cCellSecurityCube, cNodePName, cView, cGroupPName);
EndIf;
ElementSecurityPut(cRead, cApprovalDim, cNodePName, cGroupPName);

Else;

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_error_update_error_cube',
'pGuid', pExecutionId,
'pProcess', cTM1Process,
'pErrorCode', 'TI_WRONG_PERMISSION',
'pErrorDetails', cNodePName | ', ' | vRight,
'pControl', pControl);

ProcessError;

EndIf;

# IF(1)
EndIf;

#***
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'Make Application element readable');
EndIf;

cApplicationsDim = cControlPrefix | 'tp_applications';
ElementSecurityPut(cRead, cApplicationsDim, pAppId, cGroupPName);

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;


575,101


#################################################################
## IBM Confidential
##
## OCO Source Materials
##
## BI and PM: pmpsvc
##
## (C) Copyright IBM Corp. 2008, 2009
##
## The source code for this program is not published or otherwise
## divested of its trade secrets, irrespective of what has been
## deposited with the U.S. Copyright Office.
#################################################################


#*** Log File Name
cTM1Log = cEpilogLog;

#*** Zero out the values in cubes that are not in the approval subset

cAppElementSecurityCube = '}ElementSecurity_' | cApplicationsDim;
cElementSecurityCube = '}ElementSecurity_' | cApprovalDim;
cPermissionsDim = cControlPrefix | 'tp_permissions';
If (cApprovalSubsetComplementMdx @<> '');

vApprovalSubsetComplement = 'tp_temp_approval_subset_complement_' | pExecutionId;
If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, 'approval subset complement: ' | vApprovalSubsetComplement);
EndIf;

SubsetDestroy(cApprovalDim, vApprovalSubsetComplement);
SubsetCreateByMdx(vApprovalSubsetComplement, cApprovalSubsetComplementMdx);

#* Zero out cell security cube
vComplementView = 'tp_temp_cell_security_view_' | pExecutionId;
ViewCreate(cCellSecurityCube, vComplementView);
ViewColumnDimensionSet(cCellSecurityCube, vComplementView, '}Groups', 1);
ViewRowDimensionSet(cCellSecurityCube, vComplementView, cApprovalDim, 1);
ViewSubsetAssign(cCellSecurityCube, vComplementView, cApprovalDim, vApprovalSubsetComplement);
ViewTitleDimensionSet(cCellSecurityCube, vComplementView, cPermissionsDim);

ViewZeroOut(cCellSecurityCube, vComplementView);
ViewDestroy(cCellSecurityCube, vComplementView);

#* Zero out element security cube
vComplementView = 'tp_temp_element_security_view_' | pExecutionId;
ViewCreate(cElementSecurityCube, vComplementView);
ViewColumnDimensionSet(cElementSecurityCube, vComplementView, '}Groups', 1);
ViewRowDimensionSet(cElementSecurityCube, vComplementView, cApprovalDim, 1);
ViewSubsetAssign(cElementSecurityCube, vComplementView, cApprovalDim, vApprovalSubsetComplement);

ViewZeroOut(cElementSecurityCube, vComplementView);
ViewDestroy(cElementSecurityCube, vComplementView);

SubsetDestroy(cApprovalDim, vApprovalSubsetComplement);

#* Zero out application element security cube

StringGlobalVariable('gMdxFindNonUserGroups');

vReturnValue = ExecuteProcess(cControlPrefix | 'tp_mdx_find_user_groups',
'pGuid', pExecutionId,
'pAppId', pAppId,
'pControl', pControl);
If (vReturnValue <> ProcessExitNormal());
ProcessError;
EndIf;

cNonUserGroupsSubset = 'tp_temp_non_user_groups_' | pAppId | '_' | pExecutionId;
SubsetDestroy('}Groups', cNonUserGroupsSubset);
SubsetCreateByMdx(cNonUserGroupsSubset, gMdxFindNonUserGroups);

cApplicationsDim = cControlPrefix | 'tp_applications';
cSingleAppSubset = 'tp_temp_single_app_' | pAppId | '_' | pExecutionId;
SubsetDestroy(cApplicationsDim, cSingleAppSubset);
SubsetCreateByMdx(cSingleAppSubset, '{[' | cApplicationsDim | '].[' | pAppId | ']}');

cNonUserGroupsView = 'tp_temp_non_user_groups_view_' | pExecutionId;
ViewCreate(cAppElementSecurityCube, cNonUserGroupsView);
ViewColumnDimensionSet(cAppElementSecurityCube, cNonUserGroupsView, '}Groups', 1);
ViewRowDimensionSet(cAppElementSecurityCube, cNonUserGroupsView, cApplicationsDim, 1);
ViewSubsetAssign(cAppElementSecurityCube, cNonUserGroupsView, '}Groups', cNonUserGroupsSubset);
ViewSubsetAssign(cAppElementSecurityCube, cNonUserGroupsView, cApplicationsDim, cSingleAppSubset);

ViewZeroOut(cAppElementSecurityCube, cNonUserGroupsView);

ViewDestroy(cAppElementSecurityCube, cNonUserGroupsView);
SubsetDestroy('}Groups', cNonUserGroupsSubset);
SubsetDestroy(cApplicationsDim, cSingleAppSubset);

EndIf;

CubeSetLogChanges(cCellSecurityCube, 1);

#*** No error

If (cGenerateLog @= 'Y');
TextOutput(cTM1Log, TIMST(NOW, '\Y-\m-\d \h:\i:\s'), 'The end has been reached.');
EndIf;
576,
638,1
804,0
1217,0
900,
901,
902,
903,
906,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
